use strict;
package LazyFile;
use Exporter;
use File::Find;
our @ISA = qw(Exporter);
our @EXPORT = qw(readText readLines writeFile appendFile readTable writeTable printTable dirlist dirtree argGrob);
### t@C

#ꊇǂݍ
sub readText {
	my ($arg_file, $charset) = @_;
	local $/ = undef;
	my $mode = defined($charset) ? "<:encoding($charset)" : '<';
	open(IN, $mode, $arg_file) || die "can't open '$arg_file': $!";
	my $text = <IN>;
	close(IN);
	return $text;
}

#ꊇsǂݍ
sub readLines {
	return split(/\r?\n/, readText(@_));
}

#ꊇ㏑
sub writeFile {
	my ($arg_file, @text) = @_;
	my $charset;
	my ($first) = @text;
	if (ref $first) {
	  $charset = $text[1];
	  @text = @{ $first };
	}
	my $mode = defined($charset) ? ">:encoding($charset)" : '>';
	open(OUT, $mode, $arg_file) || die "can't open '$arg_file': $!";
	print OUT join("\n", @text);
	close(OUT);
}

#ꊇǋL
sub appendFile {
	my ($arg_file, @text) = @_;
	open(OUT, '>>', $arg_file) || die "can't open '$arg_file': $!";
	print OUT join("\n", @text), "\n";
	close(OUT);
}


#ꊇe[uǂݍ
sub readTable {
	my ($arg_file, $delim, @headers) = @_;
	$delim ||= "\t";
	my @rows = readLines($arg_file);
	@headers = split(/$delim/, shift @rows) if scalar(@headers)==0;
	my @table = ();
	foreach my $row (@rows) {
		my @cols = split(/$delim/, $row);
		my $record = {};
		foreach my $header (@headers) {
			$record->{$header} = shift @cols;
		}
		push(@table, $record);
	}
	return (\@table, \@headers);
}

#ꊇe[u㏑
sub writeTable {
	my ($arg_file, $table, $headers, $delim, $lf) = @_;
	my $out;
	open($out, '>', $arg_file) || die "can't open '$arg_file': $!";
	printTable($table, $headers, $delim, $lf, $out);
	close($out);
}
#ꊇe[uo
sub printTable {
	my ($table, $headers, $delim, $lf, $out) = @_;
	$delim ||= "\t";
	$lf ||= "\n";
	$out ||= *STDOUT;
	print $out join($delim, @$headers), $lf;
	foreach my $record (@$table) {
		my @cols = ();
		foreach my $header (@$headers) {
			push(@cols, $record->{$header})
		}
		print $out join($delim, @cols), $lf;
	}
}


###fBNg

#fBNg̃t@C^fBNgꗗ
sub dirlist {
	my ($arg_dir, $fh) = @_;
	opendir($fh, $arg_dir) || die "can't opendir '$arg_dir': $!";
	my @files = sort grep !/^\.\.?/, readdir($fh);
	closedir $fh;
	return @files;
}

sub dirtree {
  return find(@_);
}

###

#Windowsł̓VFAX^XNWJĂȂ߁Å֐őp
sub argGrob {
	my @args;
	push(@args,glob($_)) for @_;
	return @args;
}

1;
__END__
fileio.pm - 