#!/usr/bin/perl
# Wikipediaの辞書片の表示

use strict;
use warnings;
use Data::Dumper;
use Encode qw/decode encode/;
use utf8;
use LazyFile;

my $keyword = shift @ARGV;
$keyword = decode("shiftjis", $keyword);

my %doc = ();
my $utf8_title = '';

my $utf8_url = url_encode(encode("utf8", $keyword));
my $utf8_category = substr($utf8_url, 0, 6);
my $text = readText("wiki/$utf8_category/$utf8_url", "shiftjis");
$text = encode("shiftjis", $text);
print $text;

sub url_encode {
  my $str = shift;
  $str =~ s/([^\w ])/'%'.unpack('H2', $1)/eg;
  $str =~ tr/ /+/;
  return $str;
}

sub url_decode {
  my $str = shift;
  $str =~ tr/+/ /;
  $str =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack('H2', $1)/eg;
  return $str;
}
